diff --git a/sys/dev/raid/arcmsr/arcmsr.h b/sys/dev/raid/arcmsr/arcmsr.h
index ed91264..45edfff 100644
--- a/sys/dev/raid/arcmsr/arcmsr.h
+++ b/sys/dev/raid/arcmsr/arcmsr.h
@@ -622,23 +945,23 @@ struct QBUFFER {
 #define	ARCMSR_FW_CFGVER_OFFSET		25
 
 struct FIRMWARE_INFO {
-	u_int32_t      signature;                /*0,00-03*/
-	u_int32_t      request_len;              /*1,04-07*/
-	u_int32_t      numbers_queue;            /*2,08-11*/
-	u_int32_t      sdram_size;               /*3,12-15*/
-	u_int32_t      ide_channels;             /*4,16-19*/
-	char           vendor[40];               /*5,20-59*/
-	char           model[8];                 /*15,60-67*/
-	char           firmware_ver[16];         /*17,68-83*/
-	char           device_map[16];           /*21,84-99*/
-    u_int32_t      cfgVersion;          /*25,100-103 Added for checking of new firmware capability*/
-    char           cfgSerial[16];       /*26,104-119*/
-    u_int32_t      cfgPicStatus;        /*30,120-123*/
+	u_int32_t      signature;           /*0,00-03*/
+	u_int32_t      request_len;         /*1,04-07*/
+	u_int32_t      numbers_queue;       /*2,08-11*/
+	u_int32_t      sdram_size;          /*3,12-15*/
+	u_int32_t      ide_channels;        /*4,16-19*/
+	char           vendor[40];          /*5,20-59*/
+	char           model[8];            /*15,60-67*/
+	char           firmware_ver[16];    /*17,68-83*/
+	char           device_map[16];      /*21,84-99*/
+	u_int32_t      cfgVersion;          /*25,100-103 Added for checking of new firmware capability*/
+	char           cfgSerial[16];       /*26,104-119*/
+	u_int32_t      cfgPicStatus;        /*30,120-123*/
 };
 /*   (A) For cfgVersion in FIRMWARE_INFO
 **        if low BYTE (byte#0) >= 3 (version 3)
 **        then byte#1 report the capability of the firmware can xfer in a single request
-**
+**        
 **        byte#1
 **        0         256K
 **        1         512K
@@ -668,33 +991,43 @@ struct FIRMWARE_INFO {
 ************************************************************************************************
 */
 struct ARCMSR_CDB {
-	u_int8_t     						Bus;              /* 00h   should be 0            */
-	u_int8_t     						TargetID;         /* 01h   should be 0--15        */
-	u_int8_t     						LUN;              /* 02h   should be 0--7         */
-	u_int8_t     						Function;         /* 03h   should be 1            */
-
-	u_int8_t     						CdbLength;        /* 04h   not used now           */
-	u_int8_t     						sgcount;          /* 05h                          */
-	u_int8_t     						Flags;            /* 06h                          */
-#define ARCMSR_CDB_FLAG_SGL_BSIZE          0x01   /* bit 0: 0(256) / 1(512) bytes         */
-#define ARCMSR_CDB_FLAG_BIOS               0x02   /* bit 1: 0(from driver) / 1(from BIOS) */
-#define ARCMSR_CDB_FLAG_WRITE              0x04	  /* bit 2: 0(Data in) / 1(Data out)      */
-#define ARCMSR_CDB_FLAG_SIMPLEQ            0x00	  /* bit 4/3 ,00 : simple Q,01 : head of Q,10 : ordered Q */
-#define ARCMSR_CDB_FLAG_HEADQ              0x08
-#define ARCMSR_CDB_FLAG_ORDEREDQ           0x10
+	u_int8_t     	Bus;              /* 00h   should be 0            */
+	u_int8_t     	TargetID;         /* 01h   should be 0--15        */
+	u_int8_t     	LUN;              /* 02h   should be 0--7         */
+	u_int8_t     	Function;         /* 03h   should be 1            */
+	
+	u_int8_t     	CdbLength;        /* 04h   not used now           */
+	u_int8_t     	sgcount;          /* 05h                          */
+	u_int8_t     	Flags;            /* 06h                          */
 	u_int8_t     	msgPages;         /* 07h                          */
-
-	u_int32_t    						Context;          /* 08h   Address of this request */
-	u_int32_t    						DataLength;       /* 0ch   not used now            */
-
-	u_int8_t     						Cdb[16];          /* 10h   SCSI CDB                */
+	
+	u_int32_t    	Context;          /* 08h   Address of this request */
+	u_int32_t    	DataLength;       /* 0ch   not used now           */
+	
+	u_int8_t     	Cdb[16];          /* 10h   SCSI CDB               */
 	/*
 	********************************************************
-	**Device Status : the same from SCSI bus if error occur
+	** Device Status : the same from SCSI bus if error occur 
 	** SCSI bus status codes.
 	********************************************************
 	*/
-	u_int8_t     						DeviceStatus;     /* 20h   if error                */
+	u_int8_t     	DeviceStatus;     /* 20h   if error                */
+	
+	u_int8_t     	SenseData[15];    /* 21h   output                  */        
+	
+	union {
+		struct SG32ENTRY	sg32entry[ARCMSR_MAX_SG_ENTRIES];        /* 30h   Scatter gather address  */
+		struct SG64ENTRY	sg64entry[ARCMSR_MAX_SG_ENTRIES];        /* 30h                           */
+	} u;
+};
+/* CDB flag */
+#define ARCMSR_CDB_FLAG_SGL_BSIZE		0x01	/* bit 0: 0(256) / 1(512) bytes         */
+#define ARCMSR_CDB_FLAG_BIOS			0x02	/* bit 1: 0(from driver) / 1(from BIOS) */
+#define ARCMSR_CDB_FLAG_WRITE			0x04	/* bit 2: 0(Data in) / 1(Data out)      */
+#define ARCMSR_CDB_FLAG_SIMPLEQ			0x00	/* bit 4/3 ,00 : simple Q,01 : head of Q,10 : ordered Q */
+#define ARCMSR_CDB_FLAG_HEADQ			0x08
+#define ARCMSR_CDB_FLAG_ORDEREDQ		0x10
+/* scsi status */
 #define SCSISTAT_GOOD                  		0x00
 #define SCSISTAT_CHECK_CONDITION       		0x02
 #define SCSISTAT_CONDITION_MET         		0x04
@@ -704,17 +1037,10 @@ struct ARCMSR_CDB {
 #define SCSISTAT_RESERVATION_CONFLICT  		0x18
 #define SCSISTAT_COMMAND_TERMINATED    		0x22
 #define SCSISTAT_QUEUE_FULL            		0x28
-#define ARCMSR_DEV_SELECT_TIMEOUT               0xF0
-#define ARCMSR_DEV_ABORTED                      0xF1
-#define ARCMSR_DEV_INIT_FAIL                    0xF2
-
-	u_int8_t     						SenseData[15];    /* 21h   output                  */
-
-	union {
-		struct SG32ENTRY                sg32entry[ARCMSR_MAX_SG_ENTRIES];        /* 30h   Scatter gather address  */
-		struct SG64ENTRY                sg64entry[ARCMSR_MAX_SG_ENTRIES];        /* 30h                           */
-	} u;
-};
+/* DeviceStatus */
+#define ARCMSR_DEV_SELECT_TIMEOUT		0xF0
+#define ARCMSR_DEV_ABORTED			0xF1
+#define ARCMSR_DEV_INIT_FAIL			0xF2
 /*
 *********************************************************************
 **                   Command Control Block (SrbExtension)
@@ -724,351 +1050,196 @@ struct ARCMSR_CDB {
 *********************************************************************
 */
 struct CommandControlBlock {
-	struct ARCMSR_CDB			arcmsr_cdb;				/* 0  -503 (size of CDB=504): arcmsr messenger scsi command descriptor size 504 bytes */
-	u_int32_t					cdb_shifted_phyaddr;     /* 504-507 */
-	u_int32_t					arc_cdb_size;			/* 508-511 */
+	struct ARCMSR_CDB	arcmsr_cdb;		/* 0  -503 (size of CDB=504): arcmsr messenger scsi command descriptor size 504 bytes */
+	u_int32_t		cdb_phyaddr_low;	/* 504-507 */
+	u_int32_t		arc_cdb_size;		/* 508-511 */
 	/*  ======================512+32 bytes============================  */
-	union ccb					*pccb;					/* 512-515 516-519 pointer of freebsd scsi command */
-	struct AdapterControlBlock	*acb;					/* 520-523 524-527 */
-		bus_dmamap_t				dm_segs_dmamap;          /* 528-531 532-535 */
-		u_int16_t   				srb_flags;               /* 536-537 */
-	u_int16_t					srb_state;                /* 538-539 */
-	struct	callout				ccb_callout;
+	union ccb		*pccb;			/* 512-515 516-519 pointer of freebsd scsi command */
+	struct AdapterControlBlock	*acb;		/* 520-523 524-527 */
+	bus_dmamap_t		dm_segs_dmamap;		/* 528-531 532-535 */
+	u_int16_t   		srb_flags;		/* 536-537 */
+	u_int16_t		srb_state;              /* 538-539 */
+	u_int32_t		cdb_phyaddr_high;	/* 540-543 */
+	struct	callout		ccb_callout;
     /*  ==========================================================  */
 };
 /*	srb_flags */
-#define		SRB_FLAG_READ				0x0000
-#define		SRB_FLAG_WRITE				0x0001
-#define		SRB_FLAG_ERROR				0x0002
-#define		SRB_FLAG_FLUSHCACHE			0x0004
+#define		SRB_FLAG_READ			0x0000
+#define		SRB_FLAG_WRITE			0x0001
+#define		SRB_FLAG_ERROR			0x0002
+#define		SRB_FLAG_FLUSHCACHE		0x0004
 #define		SRB_FLAG_MASTER_ABORTED 	0x0008
-#define		SRB_FLAG_DMAVALID			0x0010
+#define		SRB_FLAG_DMAVALID		0x0010
 #define		SRB_FLAG_DMACONSISTENT  	0x0020
-#define		SRB_FLAG_DMAWRITE			0x0040
-#define		SRB_FLAG_PKTBIND			0x0080
+#define		SRB_FLAG_DMAWRITE		0x0040
+#define		SRB_FLAG_PKTBIND		0x0080
 #define		SRB_FLAG_TIMER_START		0x0080
 /*	srb_state */
-#define		ARCMSR_SRB_DONE   			0x0000
-#define		ARCMSR_SRB_UNBUILD 			0x0000
-#define		ARCMSR_SRB_TIMEOUT 			0x1111
-#define		ARCMSR_SRB_RETRY 			0x2222
-#define		ARCMSR_SRB_START   			0x55AA
-#define		ARCMSR_SRB_PENDING			0xAA55
-#define		ARCMSR_SRB_RESET			0xA5A5
-#define		ARCMSR_SRB_ABORTED			0x5A5A
-#define		ARCMSR_SRB_ILLEGAL			0xFFFF
+#define		ARCMSR_SRB_DONE   		0x0000
+#define		ARCMSR_SRB_UNBUILD 		0x0000
+#define		ARCMSR_SRB_TIMEOUT 		0x1111
+#define		ARCMSR_SRB_RETRY 		0x2222
+#define		ARCMSR_SRB_START   		0x55AA
+#define		ARCMSR_SRB_PENDING		0xAA55
+#define		ARCMSR_SRB_RESET		0xA5A5
+#define		ARCMSR_SRB_ABORTED		0x5A5A
+#define		ARCMSR_SRB_ILLEGAL		0xFFFF
+
+#define		SRB_SIZE	((sizeof(struct CommandControlBlock)+0x1f) & 0xffe0)
+#define 	ARCMSR_SRBS_POOL_SIZE   (SRB_SIZE * ARCMSR_MAX_FREESRB_NUM)
+
 /*
 *********************************************************************
 **                 Adapter Control Block
 *********************************************************************
 */
-#define ACB_ADAPTER_TYPE_A            0x00000001                /* hba I IOP */
-#define ACB_ADAPTER_TYPE_B            0x00000002                /* hbb M IOP */
-#define ACB_ADAPTER_TYPE_C            0x00000004			/* hbc L IOP */
-#define ACB_ADAPTER_TYPE_D            0x00000008                /* hbd A IOP */
+#define ACB_ADAPTER_TYPE_A	0x00000001	/* hba I IOP */
+#define ACB_ADAPTER_TYPE_B	0x00000002	/* hbb M IOP */
+#define ACB_ADAPTER_TYPE_C	0x00000004	/* hbc L IOP */
+#define ACB_ADAPTER_TYPE_D	0x00000008	/* hbd M IOP */
 
 struct AdapterControlBlock {
-	u_int32_t					adapter_type;               /* adapter A,B..... */
-
-	bus_space_tag_t					btag[2];
-	bus_space_handle_t				bhandle[2];
-	bus_dma_tag_t					parent_dmat;
-	bus_dma_tag_t					dm_segs_dmat;                         /* dmat for buffer I/O */
-	bus_dma_tag_t					srb_dmat;                             /* dmat for freesrb */
-	bus_dmamap_t					srb_dmamap;
-	device_t					pci_dev;
-	struct cdev					*ioctl_dev;
-	int						pci_unit;
-
-	struct resource				*sys_res_arcmsr[2];
-	struct resource				*irqres;
-	void						*ih;                         /* interrupt handle */
-	int						irq_type;
-
+	u_int32_t		adapter_type;		/* adapter A,B..... */
+	
+	bus_space_tag_t		btag[2];
+	bus_space_handle_t	bhandle[2];
+	bus_dma_tag_t		parent_dmat;
+	bus_dma_tag_t		dm_segs_dmat;		/* dmat for buffer I/O */  
+	bus_dma_tag_t		srb_dmat;		/* dmat for freesrb */
+	bus_dmamap_t		srb_dmamap;
+	device_t		pci_dev;
+	struct cdev		*ioctl_dev;
+	int			pci_unit;
+	
+	struct resource		*sys_res_arcmsr[2];
+	struct resource		*irqres;
+	void			*ih;			/* interrupt handle */
+	int			irq_type;
+	
 	/* Hooks into the CAM XPT */
-	struct						cam_sim *psim;
-	struct						cam_path *ppath;
-	u_int8_t					*uncacheptr;
-	unsigned long					vir2phy_offset;
+	struct			cam_sim *psim;
+	struct			cam_path *ppath;
+	u_int8_t		*uncacheptr;
+	unsigned long		vir2phy_offset;
 	union	{
-		unsigned long			phyaddr;
+		unsigned long	phyaddr;
 		struct {
-				u_int32_t		phyadd_low;
-				u_int32_t		phyadd_high;
+			u_int32_t	phyadd_low;
+			u_int32_t	phyadd_high;
 		}B;
-	} 							srb_phyaddr;
+	}srb_phyaddr;
 //	unsigned long				srb_phyaddr;
 	/* Offset is used in making arc cdb physical to virtual calculations */
-	u_int32_t					outbound_int_enable;
-
-	struct MessageUnit_UNION	*pmu;                        /* message unit ATU inbound base address0 */
-
-	u_int8_t					adapter_index;                         /*  */
-	u_int8_t					irq;
-	u_int16_t					acb_flags;                             /*  */
-
+	u_int32_t		outbound_int_enable;
+	
+	struct MessageUnit_UNION	*pmu;		/* message unit ATU inbound base address0 */
+	
+	u_int8_t		adapter_index;
+	u_int8_t		irq;
+	u_int16_t		acb_flags;
+	
 	struct CommandControlBlock *psrb_pool[ARCMSR_MAX_FREESRB_NUM];     /* serial srb pointer array */
 	struct CommandControlBlock *srbworkingQ[ARCMSR_MAX_FREESRB_NUM];   /* working srb pointer array */
-	int32_t						workingsrb_doneindex;                  /* done srb array index */
-	int32_t						workingsrb_startindex;                 /* start srb array index  */
-	int32_t						srboutstandingcount;
-
-	u_int8_t					rqbuffer[ARCMSR_MAX_QBUFFER];          /* data collection buffer for read from 80331 */
-	u_int32_t					rqbuf_firstindex;                      /* first of read buffer  */
-	u_int32_t					rqbuf_lastindex;                       /* last of read buffer   */
-
-	u_int8_t					wqbuffer[ARCMSR_MAX_QBUFFER];          /* data collection buffer for write to 80331  */
-	u_int32_t					wqbuf_firstindex;                      /* first of write buffer */
-	u_int32_t					wqbuf_lastindex;                       /* last of write buffer  */
-
-	arcmsr_lock_t					workingQ_done_lock;
-	arcmsr_lock_t					workingQ_start_lock;
-	arcmsr_lock_t					qbuffer_lock;
-
-	u_int8_t					devstate[ARCMSR_MAX_TARGETID][ARCMSR_MAX_TARGETLUN]; /* id0 ..... id15,lun0...lun7 */
-	u_int32_t					num_resets;
-	u_int32_t					num_aborts;
-	u_int32_t					firm_request_len;                      /*1,04-07*/
-	u_int32_t					firm_numbers_queue;                    /*2,08-11*/
-	u_int32_t					firm_sdram_size;                       /*3,12-15*/
-	u_int32_t					firm_ide_channels;                     /*4,16-19*/
-	u_int32_t					firm_cfg_version;
-	char						firm_model[12];	                       /*15,60-67*/
-	char						firm_version[20];                      /*17,68-83*/
-	char						device_map[20];				/*21,84-99 */
-	struct	callout				devmap_callout;
-#ifdef ARCMSR_DEBUG1
-	u_int32_t					pktRequestCount;
-	u_int32_t					pktReturnCount;
-#endif
-	u_int32_t					vendor_device_id;
-	u_int32_t					adapter_bus_speed;
+	int32_t			workingsrb_doneindex;		/* done srb array index */
+	int32_t			workingsrb_startindex;		/* start srb array index  */
+	int32_t			srboutstandingcount;
+	
+	u_int8_t		rqbuffer[ARCMSR_MAX_QBUFFER];	/* data collection buffer for read from 80331 */
+	u_int32_t		rqbuf_firstindex;		/* first of read buffer  */
+	u_int32_t		rqbuf_lastindex;		/* last of read buffer   */
+	
+	u_int8_t		wqbuffer[ARCMSR_MAX_QBUFFER];	/* data collection buffer for write to 80331  */
+	u_int32_t		wqbuf_firstindex;		/* first of write buffer */
+	u_int32_t		wqbuf_lastindex;		/* last of write buffer  */
+	
+	arcmsr_lock_t		isr_lock;
+	arcmsr_lock_t		srb_lock;
+	arcmsr_lock_t		postDone_lock;
+	arcmsr_lock_t		qbuffer_lock;
+	
+	u_int8_t		devstate[ARCMSR_MAX_TARGETID][ARCMSR_MAX_TARGETLUN]; /* id0 ..... id15,lun0...lun7 */
+	u_int32_t		num_resets;
+	u_int32_t		num_aborts;
+	u_int32_t		firm_request_len;	/*1,04-07*/
+	u_int32_t		firm_numbers_queue;	/*2,08-11*/
+	u_int32_t		firm_sdram_size;	/*3,12-15*/
+	u_int32_t		firm_ide_channels;	/*4,16-19*/
+	u_int32_t		firm_cfg_version;
+	char			firm_model[12];		/*15,60-67*/
+	char			firm_version[20];	/*17,68-83*/
+	char			device_map[20];		/*21,84-99 */
+	struct	callout		devmap_callout;
+	u_int32_t		pktRequestCount;
+	u_int32_t		pktReturnCount;
+	u_int32_t		vendor_device_id;
+	u_int32_t		adapter_bus_speed;
+	u_int32_t		maxOutstanding;
+	u_int16_t		sub_device_id;
 };/* HW_DEVICE_EXTENSION */
 /* acb_flags */
 #define ACB_F_SCSISTOPADAPTER           0x0001
-#define ACB_F_MSG_STOP_BGRB             0x0002              /* stop RAID background rebuild */
-#define ACB_F_MSG_START_BGRB            0x0004              /* stop RAID background rebuild */
-#define ACB_F_IOPDATA_OVERFLOW          0x0008              /* iop ioctl data rqbuffer overflow */
-#define ACB_F_MESSAGE_WQBUFFER_CLEARED  0x0010              /* ioctl clear wqbuffer */
-#define ACB_F_MESSAGE_RQBUFFER_CLEARED  0x0020              /* ioctl clear rqbuffer */
+#define ACB_F_MSG_STOP_BGRB             0x0002		/* stop RAID background rebuild */
+#define ACB_F_MSG_START_BGRB            0x0004		/* stop RAID background rebuild */
+#define ACB_F_IOPDATA_OVERFLOW          0x0008		/* iop ioctl data rqbuffer overflow */
+#define ACB_F_MESSAGE_WQBUFFER_CLEARED  0x0010		/* ioctl clear wqbuffer */
+#define ACB_F_MESSAGE_RQBUFFER_CLEARED  0x0020		/* ioctl clear rqbuffer */
 #define ACB_F_MESSAGE_WQBUFFER_READ     0x0040
 #define ACB_F_BUS_RESET                 0x0080
-#define ACB_F_IOP_INITED                0x0100              /* iop init */
-#define ACB_F_MAPFREESRB_FAILD		    0x0200              /* arcmsr_map_freesrb faild */
+#define ACB_F_IOP_INITED                0x0100		/* iop init */
+#define ACB_F_MAPFREESRB_FAILD		0x0200		/* arcmsr_map_freesrb faild */
 #define ACB_F_CAM_DEV_QFRZN             0x0400
-#define ACB_F_BUS_HANG_ON               0x0800              /* need hardware reset bus */
+#define ACB_F_BUS_HANG_ON               0x0800		/* need hardware reset bus */
 #define ACB_F_SRB_FUNCTION_POWER        0x1000
 /* devstate */
-#define ARECA_RAID_GONE         		0x55
-#define ARECA_RAID_GOOD         		0xaa
+#define ARECA_RAID_GONE         	0x55
+#define ARECA_RAID_GOOD         	0xaa
 /* adapter_bus_speed */
 #define	ACB_BUS_SPEED_3G	0
 #define	ACB_BUS_SPEED_6G	1
 #define	ACB_BUS_SPEED_12G	2
 /*
-*********************************************************************
-** Message Unit structure
-*********************************************************************
-*/
-struct HBA_MessageUnit
-{
-	u_int32_t				resrved0[4];	        /*0000 000F*/
-	u_int32_t				inbound_msgaddr0;	    /*0010 0013*/
-	u_int32_t				inbound_msgaddr1;	    /*0014 0017*/
-	u_int32_t				outbound_msgaddr0;	    /*0018 001B*/
-	u_int32_t				outbound_msgaddr1;	    /*001C 001F*/
-	u_int32_t				inbound_doorbell;	    /*0020 0023*/
-	u_int32_t				inbound_intstatus;	    /*0024 0027*/
-	u_int32_t				inbound_intmask;	    /*0028 002B*/
-	u_int32_t				outbound_doorbell;	    /*002C 002F*/
-	u_int32_t				outbound_intstatus;	    /*0030 0033*/
-	u_int32_t				outbound_intmask;	    /*0034 0037*/
-	u_int32_t				reserved1[2];	        /*0038 003F*/
-	u_int32_t				inbound_queueport;	    /*0040 0043*/
-	u_int32_t				outbound_queueport;     /*0044 0047*/
-	u_int32_t				reserved2[2];	        /*0048 004F*/
-	u_int32_t				reserved3[492];         /*0050 07FF ......local_buffer 492*/
-	u_int32_t				reserved4[128];         /*0800 09FF                    128*/
-	u_int32_t				msgcode_rwbuffer[256];  /*0a00 0DFF                    256*/
-	u_int32_t				message_wbuffer[32];    /*0E00 0E7F                     32*/
-	u_int32_t				reserved5[32];          /*0E80 0EFF                     32*/
-	u_int32_t				message_rbuffer[32];    /*0F00 0F7F                     32*/
-	u_int32_t				reserved6[32];          /*0F80 0FFF                     32*/
-};
-/*
-*********************************************************************
-**
-*********************************************************************
-*/
-struct HBB_DOORBELL
-{
-	u_int8_t				doorbell_reserved[ARCMSR_DRV2IOP_DOORBELL]; /*reserved */
-	u_int32_t				drv2iop_doorbell;          /*offset 0x00020400:00,01,02,03: window of "instruction flags" from driver to iop */
-	u_int32_t				drv2iop_doorbell_mask;     /*                  04,05,06,07: doorbell mask */
-	u_int32_t				iop2drv_doorbell;          /*                  08,09,10,11: window of "instruction flags" from iop to driver */
-	u_int32_t				iop2drv_doorbell_mask;     /*                  12,13,14,15: doorbell mask */
-};
-/*
-*********************************************************************
-**
-*********************************************************************
-*/
-struct HBB_RWBUFFER
-{
-	u_int8_t				message_reserved0[ARCMSR_MSGCODE_RWBUFFER];   /*reserved */
-	u_int32_t				msgcode_rwbuffer[256];      /*offset 0x0000fa00:   0,   1,   2,   3,...,1023: message code read write 1024bytes */
-	u_int32_t				message_wbuffer[32];        /*offset 0x0000fe00:1024,1025,1026,1027,...,1151: user space data to iop 128bytes */
-	u_int32_t				message_reserved1[32];      /*                  1152,1153,1154,1155,...,1279: message reserved*/
-	u_int32_t				message_rbuffer[32];        /*offset 0x0000ff00:1280,1281,1282,1283,...,1407: iop data to user space 128bytes */
-};
-/*
-*********************************************************************
-**
-*********************************************************************
-*/
-struct HBB_MessageUnit
-{
-	u_int32_t				post_qbuffer[ARCMSR_MAX_HBB_POSTQUEUE];       /* post queue buffer for iop */
-	u_int32_t				done_qbuffer[ARCMSR_MAX_HBB_POSTQUEUE];       /* done queue buffer for iop */
-	int32_t					postq_index;                                  /* post queue index */
-	int32_t					doneq_index;								   /* done queue index */
-	struct HBB_DOORBELL    *hbb_doorbell;
-	struct HBB_RWBUFFER    *hbb_rwbuffer;
-};
-
-/*
-*********************************************************************
-**
-*********************************************************************
-*/
-struct HBC_MessageUnit {
-	u_int32_t	message_unit_status;                        /*0000 0003*/
-	u_int32_t	slave_error_attribute;	                    /*0004 0007*/
-	u_int32_t	slave_error_address;	                    /*0008 000B*/
-	u_int32_t	posted_outbound_doorbell;	                /*000C 000F*/
-	u_int32_t	master_error_attribute;	                    /*0010 0013*/
-	u_int32_t	master_error_address_low;	                /*0014 0017*/
-	u_int32_t	master_error_address_high;	                /*0018 001B*/
-	u_int32_t	hcb_size;                                   /*001C 001F size of the PCIe window used for HCB_Mode accesses*/
-	u_int32_t	inbound_doorbell;	                        /*0020 0023*/
-	u_int32_t	diagnostic_rw_data;	                        /*0024 0027*/
-	u_int32_t	diagnostic_rw_address_low;	                /*0028 002B*/
-	u_int32_t	diagnostic_rw_address_high;	                /*002C 002F*/
-	u_int32_t	host_int_status;	                        /*0030 0033 host interrupt status*/
-	u_int32_t	host_int_mask;     	                        /*0034 0037 host interrupt mask*/
-	u_int32_t	dcr_data;	                                /*0038 003B*/
-	u_int32_t   dcr_address;                                /*003C 003F*/
-	u_int32_t   inbound_queueport;                          /*0040 0043 port32 host inbound queue port*/
-	u_int32_t   outbound_queueport;                         /*0044 0047 port32 host outbound queue port*/
-	u_int32_t   hcb_pci_address_low;                        /*0048 004B*/
-    u_int32_t   hcb_pci_address_high;                       /*004C 004F*/
-	u_int32_t   iop_int_status;                             /*0050 0053*/
-	u_int32_t   iop_int_mask;                               /*0054 0057*/
-    u_int32_t   iop_inbound_queue_port;                     /*0058 005B*/
-    u_int32_t   iop_outbound_queue_port;                    /*005C 005F*/
-    u_int32_t   inbound_free_list_index;                    /*0060 0063 inbound free list producer consumer index*/
-    u_int32_t   inbound_post_list_index;                    /*0064 0067 inbound post list producer consumer index*/
-    u_int32_t   outbound_free_list_index;                   /*0068 006B outbound free list producer consumer index*/
-    u_int32_t   outbound_post_list_index;                   /*006C 006F outbound post list producer consumer index*/
-    u_int32_t   inbound_doorbell_clear;                     /*0070 0073*/
-    u_int32_t   i2o_message_unit_control;                   /*0074 0077*/
-    u_int32_t   last_used_message_source_address_low;       /*0078 007B*/
-    u_int32_t   last_used_message_source_address_high;		/*007C 007F*/
-    u_int32_t   pull_mode_data_byte_count[4];               /*0080 008F pull mode data byte count0..count7*/
-    u_int32_t   message_dest_address_index;                 /*0090 0093*/
-    u_int32_t   done_queue_not_empty_int_counter_timer;     /*0094 0097*/
-    u_int32_t   utility_A_int_counter_timer;                /*0098 009B*/
-    u_int32_t   outbound_doorbell;                          /*009C 009F*/
-    u_int32_t   outbound_doorbell_clear;                    /*00A0 00A3*/
-    u_int32_t   message_source_address_index;               /*00A4 00A7 message accelerator source address consumer producer index*/
-    u_int32_t   message_done_queue_index;                   /*00A8 00AB message accelerator completion queue consumer producer index*/
-    u_int32_t   reserved0;                                  /*00AC 00AF*/
-    u_int32_t   inbound_msgaddr0;                           /*00B0 00B3 scratchpad0*/
-    u_int32_t   inbound_msgaddr1;                           /*00B4 00B7 scratchpad1*/
-    u_int32_t   outbound_msgaddr0;                          /*00B8 00BB scratchpad2*/
-    u_int32_t   outbound_msgaddr1;                          /*00BC 00BF scratchpad3*/
-    u_int32_t   inbound_queueport_low;                      /*00C0 00C3 port64 host inbound queue port low*/
-    u_int32_t   inbound_queueport_high;                     /*00C4 00C7 port64 host inbound queue port high*/
-    u_int32_t   outbound_queueport_low;                     /*00C8 00CB port64 host outbound queue port low*/
-    u_int32_t   outbound_queueport_high;                    /*00CC 00CF port64 host outbound queue port high*/
-    u_int32_t   iop_inbound_queue_port_low;                 /*00D0 00D3*/
-    u_int32_t   iop_inbound_queue_port_high;                /*00D4 00D7*/
-    u_int32_t   iop_outbound_queue_port_low;                /*00D8 00DB*/
-    u_int32_t   iop_outbound_queue_port_high;               /*00DC 00DF*/
-    u_int32_t   message_dest_queue_port_low;                /*00E0 00E3 message accelerator destination queue port low*/
-    u_int32_t   message_dest_queue_port_high;               /*00E4 00E7 message accelerator destination queue port high*/
-    u_int32_t   last_used_message_dest_address_low;         /*00E8 00EB last used message accelerator destination address low*/
-    u_int32_t   last_used_message_dest_address_high;        /*00EC 00EF last used message accelerator destination address high*/
-    u_int32_t   message_done_queue_base_address_low;        /*00F0 00F3 message accelerator completion queue base address low*/
-    u_int32_t   message_done_queue_base_address_high;       /*00F4 00F7 message accelerator completion queue base address high*/
-    u_int32_t   host_diagnostic;                            /*00F8 00FB*/
-    u_int32_t   write_sequence;                             /*00FC 00FF*/
-    u_int32_t   reserved1[34];                              /*0100 0187*/
-    u_int32_t   reserved2[1950];                            /*0188 1FFF*/
-    u_int32_t   message_wbuffer[32];                        /*2000 207F*/
-    u_int32_t   reserved3[32];                              /*2080 20FF*/
-    u_int32_t   message_rbuffer[32];                        /*2100 217F*/
-    u_int32_t   reserved4[32];                              /*2180 21FF*/
-    u_int32_t   msgcode_rwbuffer[256];                      /*2200 23FF*/
-};
-
-/*
-*********************************************************************
-**
-*********************************************************************
-*/
-struct MessageUnit_UNION
-{
-	union	{
-		struct HBA_MessageUnit				hbamu;
-		struct HBB_MessageUnit				hbbmu;
-        struct HBC_MessageUnit          	hbcmu;
-	} muu;
-};
-
-/*
 *************************************************************
 *************************************************************
 */
 struct SENSE_DATA {
-    u_int8_t 						ErrorCode:7;
-    u_int8_t 						Valid:1;
-    u_int8_t 						SegmentNumber;
-    u_int8_t 						SenseKey:4;
-    u_int8_t 						Reserved:1;
-    u_int8_t 						IncorrectLength:1;
-    u_int8_t 						EndOfMedia:1;
-    u_int8_t 						FileMark:1;
-    u_int8_t 						Information[4];
-    u_int8_t 						AdditionalSenseLength;
-    u_int8_t 						CommandSpecificInformation[4];
-    u_int8_t 						AdditionalSenseCode;
-    u_int8_t 						AdditionalSenseCodeQualifier;
-    u_int8_t 						FieldReplaceableUnitCode;
-    u_int8_t 						SenseKeySpecific[3];
+    u_int8_t 	ErrorCode:7;
+    u_int8_t 	Valid:1;
+    u_int8_t 	SegmentNumber;
+    u_int8_t 	SenseKey:4;
+    u_int8_t 	Reserved:1;
+    u_int8_t 	IncorrectLength:1;
+    u_int8_t 	EndOfMedia:1;
+    u_int8_t 	FileMark:1;
+    u_int8_t 	Information[4];
+    u_int8_t 	AdditionalSenseLength;
+    u_int8_t 	CommandSpecificInformation[4];
+    u_int8_t 	AdditionalSenseCode;
+    u_int8_t 	AdditionalSenseCodeQualifier;
+    u_int8_t 	FieldReplaceableUnitCode;
+    u_int8_t 	SenseKeySpecific[3];
 };
-/*
+/* 
 **********************************
-**  Peripheral Device Type definitions
+**  Peripheral Device Type definitions 
 **********************************
 */
-#define SCSI_DASD		      0x00	   /* Direct-access Device	   */
-#define SCSI_SEQACESS		      0x01	   /* Sequential-access device     */
-#define SCSI_PRINTER		      0x02	   /* Printer device		   */
-#define SCSI_PROCESSOR		      0x03	   /* Processor device		   */
-#define SCSI_WRITEONCE		      0x04	   /* Write-once device 	   */
-#define SCSI_CDROM		      0x05	   /* CD-ROM device		   */
-#define SCSI_SCANNER		      0x06	   /* Scanner device		   */
-#define SCSI_OPTICAL		      0x07	   /* Optical memory device	   */
-#define SCSI_MEDCHGR		      0x08	   /* Medium changer device	   */
-#define SCSI_COMM		      0x09	   /* Communications device	   */
-#define SCSI_NODEV		      0x1F	   /* Unknown or no device type    */
+#define SCSI_DASD		0x00	   /* Direct-access Device	   */
+#define SCSI_SEQACESS		0x01	   /* Sequential-access device     */
+#define SCSI_PRINTER		0x02	   /* Printer device		   */
+#define SCSI_PROCESSOR		0x03	   /* Processor device		   */
+#define SCSI_WRITEONCE		0x04	   /* Write-once device 	   */
+#define SCSI_CDROM		0x05	   /* CD-ROM device		   */
+#define SCSI_SCANNER		0x06	   /* Scanner device		   */
+#define SCSI_OPTICAL		0x07	   /* Optical memory device	   */
+#define SCSI_MEDCHGR		0x08	   /* Medium changer device	   */
+#define SCSI_COMM		0x09	   /* Communications device	   */
+#define SCSI_NODEV		0x1F	   /* Unknown or no device type    */
 /*
 ************************************************************************************************************
 **				         @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 **				                          80331 PCI-to-PCI Bridge
-**				                          PCI Configuration Space
-**
+**				                          PCI Configuration Space 
+**				
 **				         @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 **				                            Programming Interface
 **				                          ========================
@@ -1123,7 +1294,7 @@ struct SENSE_DATA {
 */
 /*
 **=============================================================================================================
-**  0x03-0x00 :
+**  0x03-0x00 : 
 ** Bit       Default             Description
 **31:16       0335h            Device ID (DID): Indicates the unique device ID that is assigned to bridge by the PCI SIG.
 **                             ID is unique per product speed as indicated.
